﻿using System;
using System.Collections.Generic;
using System.Threading;

class Program
{
    // Function to process a batch of numbers
    static void ProcessBatch(List<int> batch)
    {
        foreach (int number in batch)
        {
            int squared = number * number;
            Console.WriteLine($"Processing number: {number}, squared: {squared}");
        }
    }

    static void Main()
    {
        List<int> batch = new List<int>();
        int batchSize = 5; // Define the size of each batch

        // Simulating incoming numbers to be processed
        for (int i = 1; i <= 20; ++i)
        {
            batch.Add(i);

            // When the batch reaches the defined size, process it
            if (batch.Count == batchSize)
            {
                Console.WriteLine($"Processing a batch of {batchSize} numbers...");
                ProcessBatch(batch);
                batch.Clear(); // Clear the batch after processing
            }

            // Simulate some delay for the next number
            Thread.Sleep(100);
        }

        // Process any remaining numbers in the batch
        if (batch.Count > 0)
        {
            Console.WriteLine($"Processing the final batch of {batch.Count} numbers...");
            ProcessBatch(batch);
        }
    }
}
